//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BP.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include "neuron.h"
#include <math.h>
#include <dstring.h>

//neuron ** vrstva0;
neuron ** vrstva1;
neuron ** vrstva2;
double **vstup;         //vstup trenovacej mnoziny
double **vstup2;        //vstup testovacej mnoziny;
double *vystup;
int *poradie_vstupov;
int *test_mnozina;
int pocetchyb=0;
int pocetchyb2=0;
double epsilon=0.01;
bool lambda_ch;
int pocet1;
int pocet2;
int xold=0;
int yold =0;
int xold2=0;
int yold2=0;


int vektorsize;		//velkost vektora
int outputsize;		//velkost vystpupneho vektora
int number_of_rows;	//pocet vstupov
int number_of_rows2;

char subormeno[40];
char testmeno[40];
int binarymax=0;
triedy_vystupu *triedy;

TForm1 *Form1;

void RealToBin(double num, double* buff)
{
	double decright = num;	// separate right & left side of decimal

	// convert left side to decimal to binary

	int  j=0;
    double track;

    // convert right side to binary

	do
	{
		track = decright*2;

		if ( (track-1)<0 )
		{
			decright = track;
			buff[j++] = 0.0;
		}

		else
		{
			decright = track-1;
			buff[j++] = 1.0;
		}
	} while ((decright < 1) && (j < 16));

	//binright[j] = 0;
	//printf("\n binary of right is %s \n", binright);

}
int find_size2(void){
  char c;
  int pocet=0;
  FILE *fr=fopen("out.txt","rt");
  c=fgetc(fr);
  while(c!=EOF){
        if(c=='\n') pocet++;
        c=fgetc(fr);
  }
  fclose(fr);
  return pocet;

}


int find_vektor_size(char *name){
	FILE *f;
	char c='u';
	int pocet=0;
	if ((f = fopen(name, "rt"))== NULL)
	   return 0;

	while(c !='|'){
			c=fgetc(f);
			if(c=='\t')
				pocet++;

	   }
	fclose(f);
	return(pocet);

}
int find_vektor_size2(char *name){
	FILE *f;
	char c='u';
	int pocet=0;
	if ((f = fopen(name, "rt"))== NULL)
	   return 0;

	while(c !='\n'){
			c=fgetc(f);
			if(c=='\t')
				pocet++;

	   }
        pocet++;
	fclose(f);
	return(pocet);

}


int find_output_size(char *name){
	FILE *f;
	char c='u';
	int pocet=0;
	if ((f = fopen(name, "rt"))== NULL)
	   return 0;
	 
	while(c !='|')
			c=fgetc(f);
		


	 while(c !='\n'){
			c=fgetc(f);
			if(c=='\t')
				pocet++;

	   }
		fclose(f);
		return(pocet);

}

int find_number_of_rows(char *name){
	FILE *f;
	char c='u';
	int pocet=0;
	if ((f = fopen(name, "rt"))== NULL)
	   return 0;
	 while(c !=EOF){
			c=fgetc(f);
			if(c=='\n')
				pocet++;

	   }

		fclose(f);
		return(pocet);

}
int generator(int max){
        return( rand()% max);
}

void zorad(int max){
        int index,i,j;
        int newmax=max;
        int *pole;

        pole =new int[max];

        for(i=0;i<max;i++){
                index=generator(newmax);
                pole[i]=poradie_vstupov[index];

                for(j=index;j<newmax-1;j++)
                        poradie_vstupov[j]=poradie_vstupov[j+1];
                newmax--;
        }
         for(i=0;i<max;i++)
               poradie_vstupov[i]=pole[i];
         delete pole;


}

void init(char *name,int sizeO,int sizeI,int sizeR){
        int i,j,k;

        FILE *f;

	double cislo;
        double mom= StrToFloat(Form1->Moment->Text);
        poradie_vstupov= new int[sizeR];

        vstup=new double *[sizeR];

        for(i=0;i<sizeR;i++){
                vstup[i]= new double[sizeI];
        }

        vystup=new double[sizeR];

        if ((f = fopen(name, "rt"))== NULL){
			delete vstup; //-------musis vymazat aj 2-hu vrstvu
                        delete vystup;
			return ;
		}

        for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI;j++){
			fscanf(f,"%lf\t",&cislo);
                        vstup[i][j]=cislo;
                }

                fscanf(f,"|\t%lf\n",&cislo);
                        vystup[i]=cislo;//triedy->return_mean(cislo);


	}


        for(i=0;i<sizeR;i++){
                poradie_vstupov[i]=i;
        }


        vrstva1=new neuron *[pocet1];
        for(i=0;i<pocet1;i++){
                vrstva1[i]=new neuron(1,pocet2,sizeI,i,epsilon,mom);
        }


        vrstva2=new neuron *[pocet2];
        for(i=0;i<pocet2;i++){
                vrstva2[i]=new neuron(3,sizeO,pocet1,i,epsilon,mom);
        }

         for(i=0;i<pocet1;i++)
                for(j=0;j<pocet2;j++)
                (vrstva1[i])->nplus1[j]=vrstva2[j];//vystupny pre vrstvu 1


          for(i=0;i<pocet2;i++)
                for(j=0;j<pocet1;j++)
                (vrstva2[i])->nminus1[j]=vrstva1[j];//vstupny pre vrstvu 2

          fclose(f);
}

void init_test(char *name,int sizeO,int sizeI,int sizeR){
        int i,j,k;

        FILE *f;

	double cislo;
        vstup2=new double *[sizeR];

        for(i=0;i<sizeR;i++){
                vstup2[i]= new double[sizeI];
        }



        if ((f = fopen(name, "rt"))== NULL){
			delete vstup2; //-------musis vymazat aj 2-hu vrstvu
                        //delete vystup;
			return ;
		}

        for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI-1;j++){
			fscanf(f,"%lf\t",&cislo);
                        vstup2[i][j]=cislo;
                }

                fscanf(f,"%lf\n",&cislo);
                vstup2[i][sizeI-1]=cislo;
     
	}
        fclose(f);


}
void nullarray(int *array, int max){
 for(int i=0;i<max;i++)
        array[i]=0;
}
void binar(int cislo, int *array, int max){
	int cislo2;
        int index=0;
        if(cislo==0)
                return;
        if(cislo==1){
                array[max-1]=1;
                return;
        }
        if(cislo==2){
                array[max-2]=1;
                return;
        }
	while(1){
		if(cislo%2==1)
                        array[max-index-1]=1;
			//printf("%d",1);
		else
                        array[max-index-1]=0;
			//printf("%d",0);
                index++;
		cislo=(int)cislo/2;
		if(cislo==1){
                         array[max-index-1]=1;
			//printf("%d",1);
			break;
		}

	}
	return;
}

void make_binary_input(char *name,int sizeO,int sizeI,int sizeR){
        int i,j,k;

        FILE *f, *fo;

	double cislo;
        double max=-500;
        int power;
        int *pole;
        //poradie_vstupov= new int[sizeR];

        //vstup=new double *[sizeR];

       /* for(i=0;i<sizeR;i++){
                vstup[i]= new double[sizeI];
        }

        vystup=new double[sizeR];
         */

        if ((f = fopen(name, "rt"))== NULL){
			delete vstup; //-------musis vymazat aj 2-hu vrstvu
                        delete vystup;
			return ;
		}

        for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI;j++){
			fscanf(f,"%lf\t",&cislo);
                        if(max<cislo)
                                max=cislo;
                       // vstup[i][j]=cislo;
                }

                fscanf(f,"|\t%lf\n",&cislo);
                       // vystup[i]=triedy->return_mean(cislo);


	}
        binarymax=max;
        fclose(f);
        fo = fopen("binary.txt", "wt");
        f = fopen(name, "rt");
        power=0;
        while(1){
                if(pow(2,power)>max)
                        break;
                power++;
        }
        pole=new int[power];
        nullarray(pole, power);
        printf("\n");
        for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI;j++){
			fscanf(f,"%lf\t",&cislo);
                        binar(cislo,pole,power);
                        for(k=0;k<power;k++){
                                fprintf(fo,"%d\t",pole[k]);
                                //printf("%d\t",pole[k]);
                        }
                        nullarray(pole, power);
                }

                fscanf(f,"|\t%lf\n",&cislo);
                        fprintf(fo,"|\t%d\n",(int)cislo);
                       // printf("|\t%d\n",(int)cislo);


	}
        fclose(f);
        fclose(fo);
        delete pole;



}

//------------------------------------------------------------------------------
void make_binary_input_test(char *name,int sizeO,int sizeI,int sizeR){
        int i,j,k;

        FILE *f, *fo;

	double cislo;
        double max=-500;
        int power;
        int *pole;
        //poradie_vstupov= new int[sizeR];

        //vstup=new double *[sizeR];

       /* for(i=0;i<sizeR;i++){
                vstup[i]= new double[sizeI];
        }

        vystup=new double[sizeR];
         */

        if ((f = fopen(name, "rt"))== NULL){
			delete vstup; //-------musis vymazat aj 2-hu vrstvu
                        delete vystup;
			return ;
		}

        /*for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI;j++){
			fscanf(f,"%lf\t",&cislo);
                        if(max<cislo)
                                max=cislo;
                       // vstup[i][j]=cislo;
                }

              //  fscanf(f,"|\t%lf\n",&cislo);
                       // vystup[i]=triedy->return_mean(cislo);


	} */
        max=binarymax;
        fclose(f);
        fo = fopen("binary_test.txt", "wt");
        f = fopen(name, "rt");
        power=0;
        while(1){
                if(pow(2,power)>max)
                        break;
                power++;
        }
        pole=new int[power];
        nullarray(pole, power);
        printf("\n");
        for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI;j++){
			fscanf(f,"%lf\t",&cislo);
                        binar(cislo,pole,power);
                        for(k=0;k<power;k++){
                                fprintf(fo,"%d\t",pole[k]);
                                //printf("%d\t",pole[k]);
                        }

                        nullarray(pole, power);
                }

              //  fscanf(f,"|\t%lf\n",&cislo);
                //        fprintf(fo,"|\t%d\n",(int)cislo);
                       // printf("|\t%d\n",(int)cislo);
                fprintf(fo,"\n");

	}
        fclose(f);
        fclose(fo);
        delete pole;



}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_NasobClick(TObject *Sender)
{       FILE *f,*fw;
        double	Res[3], max=0;
	double	Res2[3*16];
        double style1,style2,sgnum1,sgnum2;
        int y,i,j,k,x;//,style1,style2,sgnum1,sgnum2;
        int pocet=find_size2();
        if((f=fopen("out.txt","rt"))==NULL)
                printf("CHYBA\n");
        fw=fopen("data.txt","wt");
        for(i=0;i<pocet;i++){
                fscanf(f,"%lf %lf %lf %lf %lf %lf %lf %d",&Res[0],&Res[1],&Res[2],&style1,&style2,&sgnum1,&sgnum2,&y);
                 max=0;
                for (j = 0; j < 3; j++){	//vyber z pola vziadalenosti to najvacsie cislo a prenormuj ostatne
                         //max+=Res[j]*Res[j];
                         if (Res[j] > max)
			        max = Res[j];
                                }
                        //max=sqrt(max);
                        for (j = 0; j < 3; j++){
			        Res[j] /= max;		//prenormovanie
			        if (Res[j] > 0.9999999999999)
		        	        Res[j] = 0.999999999999;
		}

                RealToBin(Res[0], &Res2[0]);
                RealToBin(Res[1], &Res2[16]);
	        RealToBin(Res[2], &Res2[32]);
                for(k=0;k<3*16;k++){
                //for(k=0;k<3;k++){
                        x=Res2[k];
                        fprintf(fw,"%d\t", x);
                }
                fprintf(fw,"%f\t",style1);
                fprintf(fw,"%f\t", style2);
                fprintf(fw,"%f\t", sgnum1);
                fprintf(fw,"%f\t", sgnum2);
                fprintf(fw,"|\t%d\n",y);

        }
        fclose(f);
        fclose(fw);
       this->eraseall();
       strcpy(subormeno,"data.txt");
       epsilon=StrToFloat(this->Epsilon->Text);
       pocet1=StrToInt(this->Hidden->Text);  //vektorsize;
       pocet2=1;        //outputsize;
       randomize();
       triedy=new triedy_vystupu();
       vektorsize=find_vektor_size(subormeno);
       outputsize=outputsize=find_output_size(subormeno);
       number_of_rows=find_number_of_rows(subormeno);
       triedy->parse_output(subormeno,outputsize,vektorsize,number_of_rows);
       init(subormeno,outputsize,vektorsize,number_of_rows);
       test_mnozina=new int[number_of_rows];
       for(i=0;i<number_of_rows;i++){
                if(generator(25)<=1){   //20%
                        test_mnozina[i]=1;//testovacia
                }
                else
                        test_mnozina[i]=0;
       }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_SLClick(TObject *Sender)
{
     char text[60];
     double suma=20;
     double suma2=20;
     int i,j,k,l;
     int modulo=StrToInt(this->Show->Text);
     double presnost= StrToFloat(this->Error->Text);
     int max=StrToInt(this->Maxiter->Text);
     j=0;
     //lambda_ch= this->ChLamb->Checked;
     this->Vystup->Clear();
     this->eraseall();
     pocetchyb=0;
     pocetchyb2=0;
      for(i=0;i<pocet1;i++){
                vrstva1[i]->epsilon=StrToFloat(this->Epsilon->Text);
        }



      for(i=0;i<pocet2;i++){
              vrstva1[i]->epsilon=StrToFloat(this->Epsilon->Text);
        }

     while(suma>presnost){
         zorad(number_of_rows);
         suma=0;
         suma2=0;
         for(k=0;k<number_of_rows;k++){
               l=poradie_vstupov[k];
               /* for(i=0;i<2;i++){
                        (vrstva0[i])->eval1((vstup[k])); //
                      // printf("Y= %f ",(vrstva0[i])->Y);
                }*/
               // printf("\n");
                for(i=0;i<pocet1;i++){

                        (vrstva1[i])->eval1((vstup[l]));

                }


                 for(i=0;i<pocet2;i++){
                        (vrstva2[i])->eval2();

                }
                if(test_mnozina[l]==0){
                         for(i=0;i<pocet2;i++){
                                (vrstva2[i])->adaptuj_vahy1(vystup[l]);  //

                         }

                        for(i=0;i<pocet1;i++){
                               (vrstva1[i])->adaptuj_vahy3((vstup[l]));

                         }
                }

                     /*   for(i=0;i<pocet2;i++){
                                 suma+=0.5*((vrstva2[i])->dEdYj)*((vrstva2[i])->dEdYj);
                         //if(triedy->return_real(vrstva2[i])->Y))
                        } */
                //}
               /* else{
                        for(i=0;i<pocet2;i++)
                                suma2+=0.5*(vrstva2[0]->Y -vystup[l])*(vrstva2[0]->Y -vystup[l]);
                        if(vystup[l]==1)
                                if(vrstva2[0]->Y<0.75) pocetchyb++;
                        if(vystup[l]==0)
                                if(vrstva2[0]->Y>0.25) pocetchyb++;

                }*/



        }
        //this->drawall(suma ,suma2, j);

        for(k=0;k<number_of_rows;k++){
         for(i=0;i<pocet1;i++){

                        (vrstva1[i])->eval1((vstup[k]));

                }


                 for(i=0;i<pocet2;i++){
                        (vrstva2[i])->eval2();

                }

                if(test_mnozina[k]==0){
                        suma+=0.5*(vrstva2[0]->Y -vystup[k])*(vrstva2[0]->Y -vystup[k]);
                }
               if(test_mnozina[k]==1){
                        suma2+=0.5*(vrstva2[0]->Y -vystup[k])*(vrstva2[0]->Y -vystup[k]);
               }

                if(vystup[k]==1)
                        if(vrstva2[0]->Y<0.75){
                                if(test_mnozina[k]==0)
                                        pocetchyb++;
                                else
                                        pocetchyb2++;
                         }
                if(vystup[k]==0)
                        if(vrstva2[0]->Y>0.25){
                                if(test_mnozina[k]==0)
                                        pocetchyb++;
                                else
                                        pocetchyb2++;

                        }


      }
     //-----------
	 this->drawall(suma ,suma2, j);
       /* if(pocetchyb==0){
          if(this->ChBoxOK->Checked ==true){

                sprintf(text,"Vsetky vzory boli\n spravne klasifikovane\n, pocet iteracii= %d",j);
                Application->MessageBox(text , "Klasifikovane", MB_OK);
                break;
          }
        }*/
	   if(j%modulo==0){
                this->Vystup->Lines->Add("TrainE="+(FloatToStrF(suma,ffGeneral,5,4))+" #TrainBadClass=" +(FloatToStrF(pocetchyb,ffGeneral,5,4))+"\n"+"TestE="+(FloatToStrF(suma2,ffGeneral,5,4))+" #TestBadClass=" +(FloatToStrF(pocetchyb2,ffGeneral,5,4))+"       --------------");
        //getchar();
        }
        j++;
		if(j==max-1){
                sprintf(text,"Dosiahnit presnost= %f",suma);
                Application->MessageBox(text , "Neuspesne trenovanie", MB_OK);
                this->Vystup->Lines->Add("TrainE="+(FloatToStrF(suma,ffGeneral,5,4))+" #TrainBadClass=" +(FloatToStrF(pocetchyb,ffGeneral,5,4))+"\n"+"TestE="+(FloatToStrF(suma2,ffGeneral,5,4))+" #TestBadClass=" +(FloatToStrF(pocetchyb2,ffGeneral,5,4))+"       --------------");
              break;

        }
        //if(j%500==0)
         //       printf("%f %d\n",suma,pocetchyb);
        pocetchyb=0;
        pocetchyb2=0;
       }

     /* if(suma<presnost){
      this->Vystup->Lines->Add("Chyba="+(FloatToStrF(suma,ffGeneral,5,4))+" #Zle klasif.=" +(FloatToStrF(pocetchyb,ffGeneral,5,4)));
      sprintf(text,"Bola dosiahnuta pozadovana presnost\n, pocet iteracii= %d",j);
      Application->MessageBox(text , "Klasifikovane", MB_OK);
      } */
      

}
//---------------------------------------------------------------------------

void __fastcall TForm1::B_ResetClick(TObject *Sender)
{      int i;
       for(i=0;i<pocet1;i++)
                delete vrstva1[i];

       delete vrstva1;
       for(i=0;i<pocet2;i++)
                delete vrstva2[i];
       delete vrstva2;
       for(i=0;i<number_of_rows;i++)
                delete vstup[i];
       delete vstup;

       // double **vstup2;        //vstup testovacej mnoziny;
        delete poradie_vstupov;
        delete test_mnozina;
        delete vystup;
        this->eraseall();
        this->Vystup->Clear();
       
}
//---------------------------------------------------------------------------
 /*
void __fastcall TForm1::B_ESClick(TObject *Sender)
{       int i,j;
        FILE *f;

        number_of_rows2=find_number_of_rows(testmeno);
        init_test(testmeno,outputsize,vektorsize,number_of_rows2);
        f=fopen("vystup.txt","wt");
        for(j=0;j<number_of_rows2;j++){
                for(i=0;i<pocet1;i++){
                  (vrstva1[i])->eval1(vstup2[j]);

                }


                for(i=0;i<pocet2;i++){
                  (vrstva2[i])->eval2();
                 }

                for(i=0;i<vektorsize;i++){
                 fprintf(f,"%f\t",vstup2[j][i]);
                }
         fprintf(f,"|\t%f\n",triedy->return_real(vrstva2[0]->Y));
        }
        fclose(f);

        Application->MessageBox("Bol vytvoreny subor vystup.txt", "Subor", MB_OK);

}    */
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void TForm1::eraseall(void)
{
        this->OImage->Canvas->Pen->Color=clBlack;
        this->OImage->Canvas->Rectangle(0,0,700,370);
       // this->OImage2->Canvas->Pen->Color=clBlack;
       // this->OImage2->Canvas->Rectangle(0,0,700,370);

}

void TForm1::drawall(double cislo,double cislo2,int iter){
        int i,x,y,x2,y2;
        char data[12];
        //AnsiString str1;

        this->OImage->Canvas->Pen->Color=clBlack;
        this->OImage->Canvas->MoveTo(20,350);
        this->OImage->Canvas->LineTo(700,350);
        this->OImage->Canvas->MoveTo(20,350);
        this->OImage->Canvas->LineTo(20,0);
       /*
        this->OImage2->Canvas->Pen->Color=clBlack;
        this->OImage2->Canvas->MoveTo(20,185);
        this->OImage2->Canvas->LineTo(700,185);
        this->OImage2->Canvas->MoveTo(20,350);
        this->OImage2->Canvas->LineTo(20,0);
            */
        this->OImage->Canvas->TextOutA(20,350,"1");
        //str1.sprintf("%.3lf",Sim->Tmin);
        this->OImage->Canvas->TextOutA(20,350,"1");
        //str1.sprintf("%.3lf",Sim->Tmax);
        this->OImage->Canvas->TextOutA(680,350,this->Maxiter->Text);
        //str1.sprintf("%.3lf",(Sim->Tmax -Sim->Tmin)/2.0);
        //this->OImage->Canvas->TextOutA((680-20)/2,350,str1);
        this->OImage->Canvas->TextOutA(5,340,"0");

        //str1.sprintf("%.1lf", Fitnesmean*1.5);
        this->OImage->Canvas->TextOutA(0,5,this->Xmax->Text);

        /*
        this->OImage2->Canvas->TextOutA(0,5,"4");
        this->OImage2->Canvas->TextOutA(0,350,"-4");
          */
       x=(int)(((iter)*(679.0/(StrToFloat(this->Maxiter->Text) )) ) +20);
       y=(int)(349.0-((cislo)*(349.0/(StrToFloat(this->Xmax->Text)))));
       if(y<0) y=5;
       x2=(int)(((iter)*(679.0/(StrToFloat(this->Maxiter->Text) )) ) +20);
       y2=(int)(349.0-((cislo2)*(349.0/(StrToFloat(this->Xmax->Text)))));
       if(y2<0) y2=5;

    //----    if(percept->krok==1){
      /*     xold=x;
           yold=y;
        }    */
        if(iter==0){
              xold=x;
              yold=y;
              xold2=x2;
              yold2=y2;

        }
        this->OImage->Canvas->Pen->Color=clBlue;
        this->OImage->Canvas->MoveTo(xold,yold);
        this->OImage->Canvas->LineTo(x,y);
        xold=x;
        yold=y;
        this->OImage->Canvas->Pen->Color=clRed;
        this->OImage->Canvas->MoveTo(xold2,yold2);
        this->OImage->Canvas->LineTo(x2,y2);
        xold2=x2;
        yold2=y2;


       /* for(i=0;i<percept->num+1;i++){
                
                y=(int)(185.0-((percept->w[i])*(350.0/(8.0))));
                this->OImage2->Canvas->Pen->Color= i*15000;
                if(i==0){
                        this->OImage2->Canvas->Pen->Color= 1;
                         this->OImage2->Canvas->Ellipse(x-2,y-2,x+2,y+2);
                        }

                else
                        this->OImage2->Canvas->Rectangle(x-2,y-2,x+2,y+2);
        }   8/
        /*this->OutputMemo->Lines->Clear();
        this->OutputMemo->Font->Size=10;
        for(i=0;i<Sim->maxlod-1;i++){
              str1.sprintf("%d: %.1lf\n",i+1,Sim->vypoc_vaha(Sim->stav,i));
              this->OutputMemo->Lines->Add(str1);

         }
         str1.sprintf("%d: %.1lf",i+1,Sim->vypoc_vaha(Sim->stav,i));
              this->OutputMemo->Lines->Add(str1);     */
}

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------




//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{       int j,i;
        FILE *f=fopen("vahy.txt","wt");
        for(i=0;i<pocet2;i++){
          fprintf(f,"%lf ", vrstva2[i]->wbias);
          for(j=0;j<vrstva2[i]->Nminus1;j++)
                fprintf(f,"%lf ",vrstva2[i]->w[j]);
         fprintf(f,"\n");

         }
         for(i=0;i<pocet1;i++){
          fprintf(f,"%lf ", vrstva1[i]->wbias);
          for(j=0;j<vrstva1[i]->Nminus1;j++)
                fprintf(f,"%lf ",vrstva1[i]->w[j]);
         fprintf(f,"\n");

         }
         fclose(f);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
    int j,i;
        FILE *f=fopen("vahy.txt","rt");
        for(i=0;i<pocet2;i++){
          fscanf(f,"%lf ", &(vrstva2[i]->wbias));
          for(j=0;j<vrstva2[i]->Nminus1;j++)
                fscanf(f,"%lf ",&(vrstva2[i]->w[j]));
         fscanf(f,"\n");

         }
         for(i=0;i<pocet1;i++){
          fscanf(f,"%lf ", &(vrstva1[i]->wbias));
          for(j=0;j<vrstva1[i]->Nminus1;j++)
                fscanf(f,"%lf ",&(vrstva1[i]->w[j]));
         fscanf(f,"\n");

         }
         fclose(f);
}
//---------------------------------------------------------------------------






