/**
 * \file Tasks.h
 * \date 12.02.2002
 * \author Marek Lehuta
 *
 * Constants for system tasks
 */

#ifndef SUPPORT_TASKS_H
#define SUPPORT_TASKS_H

/// Constants for system tasks
//@{
//#define INITIALIZATION_TASK		0
#define COMMUNICATION_TASK		1
#define MESSAGE_PROCESS_TASK	2
#define SYNCHRONIZATION_TASK	3
#define MEMORY_TASK				4
#define COMMANDS_TASK			5
#define SKILLS_TASK				6
#define ABILITIES_TASK			7
#define TACTICS_TASK			8
#define DEBUG_TASK				9
#define VISUALIZATION_TASK		10
#define USER_INTERACTION_TASK	11
// GP
#define CLANG_MESSAGE_PROCESS_TASK	12
//@}

#endif // SUPPORT_TASKS_H
