/**
 * \file ParseStrings.h
 * \date 30.04.2003
 *
 * Various parse strings
 */

#ifndef COMMON_PROTOCOL_PARSESTRINGS_H
#define COMMON_PROTOCOL_PARSESTRINGS_H

#include "Common/World/Types.h"

struct PLAY_MODE_TRANSLATION
{
	const char* string;
	PlayMode mode;
};

extern PLAY_MODE_TRANSLATION PLAY_MODES_LEFT[PM_MAX];
extern PLAY_MODE_TRANSLATION PLAY_MODES_RIGHT[PM_MAX];

struct LANDMARK_TRANSLATION
{
	const char* string;
	FlagType landmark;
};

extern LANDMARK_TRANSLATION LANDMARKS_LEFT[FLAG_MAX];
extern LANDMARK_TRANSLATION LANDMARKS_RIGHT[FLAG_MAX];

#endif // COMMON_PROTOCOL_PARSESTRINGS_H
