#include "triedy_vystupu.h"

triedy_vystupu::triedy_vystupu(){

}
triedy_vystupu::~triedy_vystupu(){
	int i;
	for(i=0;i<pocet;i++){
		delete vyst_triedy[i];
	}
}

double triedy_vystupu::return_mean(double hodnota){
	int i;
	for(i=0;i<pocet;i++){
		if(vyst_triedy[i]->real==hodnota)
			break;
	}
        if(i==pocet) i=pocet-1;
	return(vyst_triedy[i]->mean);
}
double triedy_vystupu::return_real(double hodnota){
	int i;
	for(i=0;i<pocet;i++){
		if((vyst_triedy[i]->down < hodnota)&&(vyst_triedy[i]->upper >= hodnota))
			break;
	}
        if(i==pocet) i=pocet-1;
	return(vyst_triedy[i]->real);
}
//vystup_data **vyst_triedy;


bool triedy_vystupu::isin(double *pole,double cislo,int maxsize){
	for(int i=0;i<maxsize;i++){
		if(pole[i]==cislo)
			return(true);
	}
	return(false);
}
void triedy_vystupu::parse_output(char *name,int sizeO,int sizeI,int sizeR){
	FILE *f;
	int i,j,poc=0;
	double *pole=new double[sizeR];
	double cislo;
//	char c;

	for(i=0;i<sizeR;i++)
			pole[i]=-200;
		if ((f = fopen(name, "rt"))== NULL){
			delete pole;
			return ;
		}

	for(i=0;i<sizeR;i++){
		for(j=0;j<sizeI;j++)
			fscanf(f,"%lf\t",&cislo);

		fscanf(f,"|\t%lf\n",&cislo);
		if(!(isin(pole, cislo,sizeR))){
			pole[poc]=cislo;
			poc++;
		}


	}

	usporiadaj(pole,poc);
	vyst_triedy= new vystup_data *[poc];

	for(i=0;i<poc;i++)
		vyst_triedy[i]=new vystup_data();

	double delta=1.0/poc;
	
	vyst_triedy[0]->set(0, delta,pole[0]); 

	for(i=1;i<poc;i++){
		vyst_triedy[i]->set(vyst_triedy[i-1]->upper, vyst_triedy[i-1]->upper + delta,pole[i]);
	}
	fclose(f);
	pocet=poc;
	return;

}
void triedy_vystupu::usporiadaj(double *pole,int max){
	int i,j;
	double pom;
	for(i=0;i<max;i++){
		for(j=i+1;j<max;j++){
			if(pole[i] > pole[j]){
			pom=pole[i];
			pole[i]=pole[j];
			pole[j]=pom;
			}
		}
	}

	/*for(i=0;i<pocet;i++){
		for(j=i+1;j<pocet;j++){
			if(vyst_triedy[i]->real > vyst_triedy[j]->real){
				pom=vyst_triedy[i]->down;
				vyst_triedy[i]->down=vyst_triedy[j]->down;
				vyst_triedy[j]->down=pom;
				
				pom=vyst_triedy[i]->upper;
				vyst_triedy[i]->upper=vyst_triedy[j]->upper;
				vyst_triedy[j]->upper=pom;
				
				pom=vyst_triedy[i]->mean;
				vyst_triedy[i]->mean=vyst_triedy[j]->mean;
				vyst_triedy[j]->mean=pom;

				pom=vyst_triedy[i]->real;
				vyst_triedy[i]->real=vyst_triedy[j]->real;
				vyst_triedy[j]->real=pom;

			
			}
		}
	}*/
}