/**
 * \file Tactics.h
 * \date 12.03.2001
 *
 * Interface for the TacticsInterface class
 */

#ifndef INTERFACES_TACTICS_H
#define INTERFACES_TACTICS_H

#include "Common/Interfaces/Interface.h"

/**
 * \class TacticsInterface
 * \author Marek Lehuta
 * \brief Tactics task interface
 * 
 * Tactics task decides actions to perform
 */

class TacticsInterface : public Interface
{
public:
	// Construction and destruction
	TacticsInterface() : Interface("Tactics interface", "v0.0.01") {}
	virtual ~TacticsInterface() {}


	// Interface functions
//	virtual void Act() = 0;
//	virtual void Start() = 0;
    virtual void ChangeFormation(const char* formation) = 0;

protected:

private:

};

#endif // INTERFACES_TACTICS_H
