<?xml version="1.0" encoding="iso-8859-2" ?> 
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
>
<xsl:output method="text"/>
<xsl:strip-space elements="*"/>
<xsl:variable name="vzdialenost" select="0"/>

	<xsl:template match= "/hra">
		<xsl:apply-templates select="Prihravka"/>
	</xsl:template>

	<!-- vyberiem len tie prihravky, ktorych nasledujucou je prihravka supera alebo prihravka spoluhraca s cislom, ktoremu som prihraval 
	pricom ostatne pripady odfiltrujem -->

	<xsl:template match="Prihravka[@super='0']
				      [(following-sibling::node()[1]/Cas - ./Cas) &lt; 40]
				      [(following-sibling::node()[1]/Cas - ./Cas) &gt; 2]
				      [following-sibling::node()[1][@super='1']/Kto/Cislo=Protivnik/Cislo or 
				       following-sibling::node()[1][@super='0']/Kto/Cislo=Komu/Cislo]"> 
	   <xsl:choose>
		<xsl:when test="following-sibling::node()[1][@super='0']/Kto/Cislo=Komu/Cislo">
			<xsl:apply-templates select="Protivnik[not(VektorKtoEn/KolmaV = 100.0)]"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:apply-templates select="Protivnik[Cislo=../following-sibling::node()[1]/Kto/Cislo]"/>
		</xsl:otherwise>
	   </xsl:choose>
	</xsl:template>


	<xsl:template match="Protivnik">
<!--	   <xsl:element name="Pozicia"> 
		<xsl:copy-of select=".|../Kto|../Komu"/>		-->
		<xsl:text> </xsl:text>
		<xsl:value-of select = "../VektorKtoKomu/Dlzka"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select = "VektorKtoEn/Dlzka"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select = "VektorKtoEn/KolmaV"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select = "../@typ"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select = "../@typ"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select = "VektorKtoEn/Smer"/>
		<xsl:text> </xsl:text>
		<xsl:value-of select = "VektorKtoEn/Smer"/>
		<xsl:text> </xsl:text>
		<xsl:choose>
			<xsl:when test="../following-sibling::node()[1]/@super='1'">
				<xsl:text>0</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>1</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
	   <xsl:text>
</xsl:text>
<!--	   </xsl:element> -->
	</xsl:template>


	<xsl:template match="Prihravka"/>

</xsl:stylesheet>